<div class="tree-menu-wrapper">
  <mat-toolbar class="mat-elevation-z3" [ngClass]="{ 'bg-eu': isMonitoring }">
    @if (isMonitoring) {
      <mat-toolbar-row>
        <h3 class="fw-700">Data Space tree view</h3>
        <mat-icon color="primary" class="info-icon ml-1 fs-18"> info </mat-icon>
      </mat-toolbar-row>
    }
    <mat-toolbar-row>
      <mat-form-field class="dataspace-tree-search" appearance="fill">
        <mat-label>Nodes, categories, components</mat-label>
        <mat-icon matPrefix>search</mat-icon>
        <input
          class="simplut-menu-filter"
          matInput
          type="text"
          [(ngModel)]="filterValue"
        />

        @if (filterValue) {
          <button
            matSuffix
            mat-icon-button
            aria-label="Clear"
            (click)="filterValue = ''"
          >
            <mat-icon>close</mat-icon>
          </button>
        }
      </mat-form-field>

      <span class="spacer"></span>

      <button
        color="primary"
        mat-icon-button
        aria-label="Icon-button with filter alt icon"
        disabled
      >
        <mat-icon color="primary" class="material-icons-outlined">
          filter_alt
        </mat-icon>
      </button>
    </mat-toolbar-row>
  </mat-toolbar>

  <mat-tree [dataSource]="treeFlatDataSource" [treeControl]="treeControl">
    <mat-tree-node
      *matTreeNodeDef="let node"
      matTreeNodePadding
      [style.display]="filterLeafNode(node) ? 'none' : 'flex'"
    >
      <button mat-icon-button disabled></button>

      @if (isMonitoring) {
        <span class="fw-700 text-primary-900">&bull; &nbsp;&nbsp;&nbsp;</span>
      }

      <span
        [ngClass]="{
          'fw-700 cursor-pointer': isMonitoring,
          'text-primary underlined-text': isMonitoring && !isSelected(node),
          'text-primary-900': isMonitoring && isSelected(node)
        }"
        (click)="onTreeMenuNodeClick(node)"
        (keydown)="onTreeMenuNodeClick(node)"
      >
        {{
          (node.name | titlecaseNodeName)
            ?.replace("FE", "Front-end")
            ?.replace("BE", "Back-end")
        }}
      </span>
    </mat-tree-node>

    <mat-tree-node
      *matTreeNodeDef="let node; when: hasChild"
      matTreeNodePadding
      [style.display]="filterParentNode(node) ? 'none' : 'flex'"
      [ngClass]="{ 'border-grey-300': !isMonitoring && node.level === 0 }"
      class="slabs-tree-node"
    >
      <button
        class="simplut-tree-node-btn"
        mat-icon-button
        matTreeNodeToggle
        [attr.aria-label]="'Toggle ' + node.name"
        (click)="onTreeMenuNodeClick(node)"
      >
        <mat-icon
          class="mat-icon-rtl-mirror"
          [ngClass]="{ 'text-primary-900': isMonitoring }"
        >
          {{ treeControl.isExpanded(node) ? "arrow_drop_down" : "arrow_right" }}
        </mat-icon>
      </button>
      <span
        [ngClass]="{
          'fw-700': isMonitoring,
          'text-primary underlined-text':
            isMonitoring && !treeControl.isExpanded(node),
          'text-primary-900': isMonitoring && treeControl.isExpanded(node)
        }"
        class="cursor-pointer"
        matTreeNodeToggle
        (click)="onTreeMenuNodeClick(node)"
        (keydown)="onTreeMenuNodeClick(node)"
      >
        {{ node.name | titlecaseNodeName }}
      </span>
      @if (showNodeMenu(node)) {
        <span class="spacer"></span>
        <button
          class="simplut-node-menu-btn"
          mat-icon-button
          aria-label="Icon button with a horizontal three dot icon"
          (click)="openOptionsMenu($event, node)"
        >
          <mat-icon>more_horiz</mat-icon>
        </button>
      }
    </mat-tree-node>
  </mat-tree>
</div>

<app-options-menu
  [node]="graphChartDatum"
  [nodeList]="nodeList"
></app-options-menu>
